<script setup lang="ts">
import type { BaseHero } from '@/types/base';
import ArrowIcon from '~/assets/icons/arrow.vue';

defineProps<BaseHero>();
</script>

<template>
  <section class="single-column-hero slp-mb-96">
    <SlpContainer>
      <SlpRow>
        <SlpColumn class="slp-flex slp-flex-column slp-justify-content-center single-column-hero__text">
          <SlpTypography v-if="tagline" tag="p" variant="body3-bold" class="single-column-hero__tagline"
            >{{ tagline }}
          </SlpTypography>
          <SlpTypography
            tag="h1"
            variant="heading1-bold"
            class="slp-mt-48 slp-mt-md-0 slp-mb-16"
            data-aos="zoom-in-up"
            data-aos-duration="500"
            >{{ title }}
          </SlpTypography>
          <SlpTypography
            v-if="description"
            data-aos="zoom-in-up"
            data-aos-duration="1000"
            :variant="config?.typographyVariants?.description || 'body1'"
            tag="div"
          >
            <div v-html="$md.render(description)"></div>
          </SlpTypography>
          <SlpButton
            v-if="primaryButton"
            variant="primary"
            class="slp-mt-32 primary-btn"
            :data-ga-name="primaryButton.config.dataGaName"
            :data-ga-location="primaryButton.config.dataGaLocation"
            :href="primaryButton.config.href"
            >{{ primaryButton.text
            }}<ArrowIcon v-if="primaryButton.config.icon" class="slp-ml-4" direction="down" fill="#FFFFFF" />
          </SlpButton>
        </SlpColumn>
        <div v-if="image" class="single-column-hero__image-container">
          <div class="single-column-hero__image slp-my-32 slp-my-md-64 slp-ml-32 slp-ml-md-64">
            <img :src="image.config?.src" :alt="image?.altText" loading="lazy" format="webp" quality="99" />
          </div>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.single-column-hero {
  overflow: hidden;
  position: relative;
  background-color: $color-surface-800;
  padding: $spacing-64 0;

  &__text {
    position: relative;
    max-width: 65%;
    z-index: 2;

    @media (max-width: $breakpoint-md) {
      max-width: 100%;
    }
  }

  &__title {
    margin-top: 0;
    margin-bottom: 16px;

    @media (max-width: $breakpoint-md) {
      margin-top: 0;
    }
  }

  &__description {
    font-size: $text-body-1;
    line-height: $line-height-body-1;
  }

  &__tagline {
    border-radius: 20px;
    border: 1px solid $color-surface-950;
    background: $color-surface-800;
    padding: $spacing-4 12px;
    width: fit-content;
    margin-bottom: $spacing-64;
  }

  &__image-container {
    position: absolute;
    left: 0;

    @media (min-width: $breakpoint-md) {
      left: 40%;
    }
  }

  &__image {
    display: flex;
    justify-content: left;
    align-items: center;

    @media (max-width: $breakpoint-md) {
      position: absolute;
      top: 18rem;
    }

    img {
      width: 130vw;

      @media (min-width: $breakpoint-md) {
        width: 69vw;
        min-width: 69vw;
      }

      @media (min-width: $breakpoint-lg) {
        width: 65vw;
        min-width: 65vw;
      }
    }
  }

  .primary-btn {
    width: fit-content;

    @media (max-width: $breakpoint-lg) {
      width: 100%;
      justify-content: center;
    }

    &:hover {
      svg {
        fill: $color-secondary-300;
      }
    }
  }
}
</style>
